#if defined(UNICODE) && !defined(_UNICODE)
    #define _UNICODE
#elif defined(_UNICODE) && !defined(UNICODE)
    #define UNICODE
#endif

#define _WIN32_WINNT 0x0501
#define _WIN32_IE 0x0501

#include <tchar.h>
#include <windows.h>
#include <commctrl.h>

#define IDC_BUTTON01 1001
#define IDC_BUTTON02 1002

/* Declare Windows procedure */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
void bgPaintButton(HWND hwnd, HWND hwndButton);
/* Subclassing fonksiyon bildirimi */
LRESULT CALLBACK ButtonProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam, UINT_PTR uIdSubclass, DWORD_PTR dwRefData);

/*  Make the class name into a global variable  */
TCHAR szClassName[ ] = _T("CodeBlocksWindowsApp");

HWND hwndButton01, hwndButton02;

/* Subclassing fonksiyonu iinde WM_MOUSEMOVE mesajn takip eden deikenler */
int inButton;
HWND hwndactButton;

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default colour as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           _T("Bitmap Button"), /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           400,                 /* The programs width */
           300,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nCmdShow);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}

/* This function is called by the Windows function DispatchMessage() */
LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                  /* handle the messages */
    {
         case WM_CREATE:
         {
              // Owner drawn button
              hwndButton01 = CreateWindowEx(0, "BUTTON", "Button01",
                                 WS_CHILD | WS_VISIBLE | BS_BITMAP, 20, 20, 120, 25,
                                 hwnd, (HMENU) IDC_BUTTON01, NULL, NULL);
              // Subclassing ilemi uygulama
              SetWindowSubclass(hwndButton01, ButtonProc, 0, 0);

              bgPaintButton(hwnd, hwndButton01);

              hwndButton02 = CreateWindowEx(0, "BUTTON", "Button02",
                                 WS_CHILD | WS_VISIBLE | BS_BITMAP, 20, 60, 120, 25,
                                 hwnd, (HMENU) IDC_BUTTON02, NULL, NULL);
              SetWindowSubclass(hwndButton02, ButtonProc, 0, 0);

              bgPaintButton(hwnd, hwndButton02);


         }
         break;

         case WM_COMMAND:
         {
              if (HIWORD(wParam) == BN_CLICKED) {
                  switch(LOWORD(wParam)) {
                    case IDC_BUTTON01:
                         MessageBox(NULL, "Button01 tkland.", "Buton tklama", MB_OK);
                         break;
                    case IDC_BUTTON02:
                         MessageBox(NULL, "Button02 tkland.", "Buton tklama", MB_OK);
                         break;
                  }
              }
         }
         break;

         case WM_DESTROY:
             PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
             break;

         default:                       /* for messages that we don't deal with */
             return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

void bgPaintButton(HWND hwnd, HWND hwndButton)
{
  HDC hdc, hMemDC;
  HBITMAP hBitmap;
  RECT rc = {0};
  char cdizi[40];

  GetClientRect(hwndButton, &rc);

  hdc = GetDC(hwnd);
  hMemDC = CreateCompatibleDC(hdc);
  hBitmap = CreateCompatibleBitmap(hdc, rc.right, rc.bottom);
  SelectObject(hMemDC, hBitmap);

  if (inButton && (hwndactButton == hwndButton)) { // Mouse zerinde
      SetDCBrushColor(hMemDC, RGB(230, 180, 230));
      SetTextColor(hMemDC, RGB(236, 236, 236));
  }
  else {
      SetDCBrushColor(hMemDC, RGB(200, 130, 200));
      SetTextColor(hMemDC, RGB(220, 220, 220));
  }

  FillRect(hMemDC, &rc, (HBRUSH)GetStockObject(DC_BRUSH));
  SetBkMode(hMemDC, TRANSPARENT);

  GetWindowText(hwndButton, cdizi, sizeof(cdizi));
  DrawText(hMemDC, cdizi, strlen(cdizi), &rc, DT_CENTER | DT_VCENTER | DT_SINGLELINE);

  DeleteDC(hMemDC);
  ReleaseDC(hwnd, hdc);

  SendMessage(hwndButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hBitmap);
}

/* Subclassing fonksiyonu */
LRESULT CALLBACK ButtonProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam, UINT_PTR uIdSubclass, DWORD_PTR dwRefData)
{
  switch (message) {

    case WM_MOUSEMOVE:
     {
         hwndactButton = hwnd;

         if (GetCapture() != hwnd) {
            // Mouse button penceresine henz girdi.
            inButton=1;
            SetCapture(hwnd);
            bgPaintButton(GetParent(hwnd), hwnd);

         }
         else {
            RECT rect;
            POINT pt = { LOWORD(lParam), HIWORD(lParam) };

            GetWindowRect(hwnd, &rect);
            ClientToScreen(hwnd, &pt);

            if (!PtInRect(&rect, pt)) {
                // Mouse button penceresinden ayrld.
                inButton=0;
                ReleaseCapture();
                bgPaintButton(GetParent(hwnd), hwnd);
            }
         }
     }
     break;
  }

  return DefSubclassProc(hwnd, message, wParam, lParam);
}
